%define _duplicate_files_terminate_build 0

%ifarch %{ix86}
%define distarch 32
%define MINRAM 1024 
%endif
%ifarch x86_64
%define distarch 64
%define MINRAM 1024 
%endif
%define productURL 'http://rosalab.ru/products/desktop/'

%define fresh_platform 2014.1

Summary:	Configs to change branding in one place
Name:		branding-configs
Version:	2.0
Release:	105
License:	GPL
Group:		System/Base
# common files
Source1:	en_license.html
Source2:	ru_license.html
Source3:	branding-system
Source4:	10rosa-release.sh
Source5:	10rosa-release.csh

# index.html
Source10:	index.html.cert
Source11:	index.html.fresh
Source12:	index.html.red

# Auxilliary files for index.html to make it 
# look beautiful in offline mode
Source101:	main.css
Source102:	images.tar.gz

# os-release
Source20:	os-release.cert
Source21:	os-release.fresh
Source22:	os-release.red

# Release notes
Source30:	release-notes-ru-Chrome.html
Source31:	release-notes-ru-Chrome.txt
Source32:	release-notes-ru-Cobalt.html
Source33:	release-notes-ru-Cobalt.txt
Source34:	release-notes-fresh.txt
Source35:	release-notes-red.txt
Source36:	release-notes-ru-Nickel.html
Source37:	release-notes-ru-Nickel.txt

# Branding macros
Source40:	branding.macros.cert
Source41:	branding.macros.fresh
Source42:	branding.macros.red

# Fresh/RED only
Source50:	CREDITS.fresh

%description
Quick and easy way to change distribution branding in one place.

%package common
Summary:	Branding common files
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	lsb-release
Conflicts:	lsb-release < 2.0-49

# cf mdvbz#32631
Provides:	arch(%{_target_cpu})
Provides:	mandriva-release-common
#Provides:	%{name} = %{EVRD}
%rename	rosa-release-common

%description common
Common files for ROSA Desktop release packages.

%if %{product_product} == "Certified"
%package Chrome
Summary:	ROSA release file for Chrome
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	rpm
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release
Provides:	mandriva-release mandrakelinux-release rosa-release
Provides:	%{name} = %{EVRD}
%rename		%{name}-Cobalt
%rename		indexhtml

%description Chrome
Release file for Chrome flavour.

%package Cobalt
Summary:	ROSA release file for Cobalt
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release 
Provides:	mandriva-release mandrakelinux-release rosa-release 
Provides:	%{name} = %{EVRD}
%rename		%{name}-Chrome
%rename		indexhtml

%description Cobalt
Release file for Cobalt flavour.

%package current
Summary:	ROSA release file for current platform
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release 
Provides:	mandriva-release mandrakelinux-release
Provides:	%{name} = %{EVRD}
%rename		%{name}-current
%rename		indexhtml

%description current
Release file for current flavour.


%package Nickel
Summary:	ROSA release file for Nickel
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	rpm
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release
Provides:	mandriva-release mandrakelinux-release rosa-release
Provides:	%{name} = %{EVRD}
%rename		indexhtml

%description 
Release file for Nickel flavour.

%endif

%if %{product_product} == "Enterprise"
%package red
Summary:	ROSA release file for the Enterprise platform
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release
Provides:	mandriva-release mandrakelinux-release
Provides:	%{name} = %{EVRD}
Obsoletes:	branding-configs-fresh
# some number greater than 2014.1 to override rosa-release-common & co in Fresh
%rename	rosa-release-common 2024
%rename	rosa-release-EE 2024
%rename	rosa-release-Free 2024
%rename	rosa-release 2024
%rename	indexhtml 2024

%description red
Release file for the Enterprise flavour.

%endif

# Historically Fresh was divided to EE and Free
%if %{product_product} == "EE" || %{product_product} == "Free" || %{product_product} == "Fresh"
%package fresh
Summary:	ROSA release file for the Fresh platform
Group:		System/Base
Requires:	update-alternatives
Requires(pre):	branding-configs-common
Requires(post):	coreutils
Requires(post):	grub2
Provides:	redhat-release rawhide-release mandrake-release 
Provides:	mandriva-release mandrakelinux-release rosa-release 
Provides:	%{name} = %{EVRD}
# some number greater than 2014.1 to override rosa-release-common & co in Fresh
%rename	rosa-release-common 2024
%rename	rosa-release-EE 2024
%rename	rosa-release-Free 2024
%rename	rosa-release 2024
%rename	indexhtml 2024

%description fresh
Release file for the Fresh flavour.

%endif

%prep
cp -a %{SOURCE30} release-notes-ru-Chrome.html
cp -a %{SOURCE31} release-notes-ru-Chrome.txt
cp -a %{SOURCE32} release-notes-ru-Cobalt.html
cp -a %{SOURCE33} release-notes-ru-Cobalt.txt
cp -a %{SOURCE32} release-notes-ru-current.html
cp -a %{SOURCE33} release-notes-ru-current.txt
cp -a %{SOURCE34} release-notes-fresh.txt
cp -a %{SOURCE35} release-notes-red.txt
cp -a %{SOURCE36} release-notes-ru-Nickel.html
cp -a %{SOURCE37} release-notes-ru-Nickel.txt
cp -a %{SOURCE21} os-release.fresh
cp -a %{SOURCE22} os-release.red
cp -a %{SOURCE41} branding.macros.fresh
cp -a %{SOURCE42} branding.macros.red
cp -a %{SOURCE11} index.html.fresh
cp -a %{SOURCE12} index.html.red
cp -a %{SOURCE50} CREDITS

cat > README.urpmi.cert <<EOF
This is ROSA Desktop Certified

You can find the release notes in %{_docdir}/%{name}-common/release-notes.txt

or on the web at %{productURL}
EOF

cat > README.urpmi.fresh <<EOF
This is ROSA Desktop Fresh

You can find the release notes on the web at http://wiki.rosalab.ru
EOF

cat > README.urpmi.red <<EOF
This is ROSA Enterprise Desktop

You can find the release notes on the web at http://wiki.rosalab.ru
EOF

cat > product.id.fresh << EOF
vendor=ROSA,distribution=ROSA Desktop Fresh R8.1,type=Basic,version=%{fresh_platform},branch=Official,release=1,arch=%{_target_cpu},product=EE
EOF

cat > product.id.red << EOF
vendor=ROSA,distribution=ROSA Enterprise Desktop X3,type=Basic,version=%{fresh_platform},branch=Official,release=1,arch=%{_target_cpu},product=Enterprise
EOF

cat > product.id.cert << EOF
vendor=ROSA Marathon,distribution=ROSA Marathon,type=Basic,version=%{fresh_platform},branch=Official,release=1,arch=%{_target_cpu},product=Certified
EOF

%if %{product_product} == "EE" || %{product_product} == "Free" || %{product_product} == "Fresh"
# check that CREDITS file is in UTF-8, fail otherwise
if iconv -f utf-8 -t utf-8 < %{SOURCE50} > /dev/null
then
        true
else
        echo "the CREDITS file *MUST* be encoded in UTF-8"
        echo "please fix it before continuing"
        false
fi
%endif

cat > minsysreqs << EOF
ram = %{MINRAM}
hdd = 10
EOF

cat > desktop << EOF
DESKTOP=KDE4
DISPLAYMANAGER=kdm
EOF

%install
mkdir %{buildroot}%{_sysconfdir}
touch %{buildroot}%{_sysconfdir}/lsb-release
touch %{buildroot}%{_sysconfdir}/os-release
touch %{buildroot}%{_sysconfdir}/system-release

# Commons
mkdir -p %{buildroot}%{_datadir}/%{name}
install -m 0644 %{SOURCE1} %{buildroot}%{_datadir}/%{name}/
install -m 0644 %{SOURCE2} %{buildroot}%{_datadir}/%{name}/
install -m 0644 %{SOURCE4} %{buildroot}%{_datadir}/%{name}/
install -m 0644 %{SOURCE5} %{buildroot}%{_datadir}/%{name}/
install -m 0644 %{SOURCE3} %{buildroot}%{_datadir}/%{name}/

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m 0644 minsysreqs %{buildroot}%{_sysconfdir}/
install -m 0644 desktop %{buildroot}%{_sysconfdir}/sysconfig/

mkdir -p %{buildroot}%{_datadir}/doc/HTML

# Cert systems
%if %{product_product} == "Certified"
for i in "Chrome 1.0" "Cobalt 1.0" "current 1.0" "Nickel 1.0"
do
%define flavour ${i% *}
%define reln ${i##* }
%define productNameEN "OS ROSA DX%{distarch} %{flavour} %{reln}"
mkdir -p %{buildroot}%{_datadir}/%{name}/%{flavour}/
echo %{productNameEN} > %{buildroot}%{_datadir}/%{name}/%{flavour}/rosa-release

install -m 0644 release-notes-ru-%{flavour}.html %{buildroot}%{_datadir}/%{name}/%{flavour}/release-notes-ru.html
install -m 0644 release-notes-ru-%{flavour}.txt %{buildroot}%{_datadir}/%{name}/%{flavour}/release-notes-ru.txt
install -m 0644 release-notes-ru-%{flavour}.html %{buildroot}%{_datadir}/%{name}/%{flavour}/release-notes-en.html
install -m 0644 release-notes-ru-%{flavour}.txt %{buildroot}%{_datadir}/%{name}/%{flavour}/release-notes-en.txt
install -m 0644 %{SOURCE10} %{buildroot}%{_datadir}/%{name}/%{flavour}/index.html
install -m 0644 %{SOURCE20} %{buildroot}%{_datadir}/%{name}/%{flavour}/os-release
install -m 0644 product.id.cert %{buildroot}%{_datadir}/%{name}/%{flavour}/product.id
install -m 0644 README.urpmi.cert %{buildroot}%{_datadir}/%{name}/%{flavour}/README.urpmi
install -m 0644 %{SOURCE40} %{buildroot}%{_datadir}/%{name}/%{flavour}/branding.macros
sed -i -e s/'#productName'/%{productNameEN}/g %{buildroot}%{_datadir}/%{name}/%{flavour}/index.html
sed -i -e s,'#productURL',%{productURL},g %{buildroot}%{_datadir}/%{name}/%{flavour}/index.html

install -m 0644 %{SOURCE101} %{buildroot}%{_datadir}/%{name}/%{flavour}/
pushd %{buildroot}%{_datadir}/%{name}/%{flavour}/
tar xzvf %{SOURCE102}
popd

cat > %{buildroot}%{_datadir}/%{name}/%{flavour}/lsb-release << EOF
LSB_VERSION=
DISTRIB_ID=Rosa.DX%{distarch}
DISTRIB_RELEASE=%{reln}
DISTRIB_CODENAME=%{flavour}
DISTRIB_DESCRIPTION="ROSA DX%{distarch} %{flavour} %{reln}"
EOF

echo "ROSA DX%{distarch} %{flavour} %{reln}" > %{buildroot}%{_datadir}/%{name}/%{flavour}/issue
echo "Kernel \r (\l)" >> %{buildroot}%{_datadir}/%{name}/%{flavour}/issue
cp -p %{buildroot}%{_datadir}/%{name}/%{flavour}/issue %{buildroot}%{_datadir}/%{name}/%{flavour}/issue.net
echo >> %{buildroot}%{_datadir}/%{name}/%{flavour}/issue

done

%endif # product_product == Certified

# Fresh and RED
%if %{product_product} == "EE" || %{product_product} == "Free" || %{product_product} == "Fresh"
mkdir -p %{buildroot}%{_datadir}/%{name}/fresh
echo "ROSA Desktop Fresh R8.1 release %{fresh_platform} for %{_target_cpu}" > %{buildroot}%{_datadir}/%{name}/fresh/rosa-release

cp -p %{buildroot}%{_datadir}/%{name}/fresh/rosa-release %{buildroot}%{_datadir}/%{name}/fresh/issue
echo "Kernel \r on an \m (\l)" >> %{buildroot}%{_datadir}/%{name}/fresh/issue
cp -p %{buildroot}%{_datadir}/%{name}/fresh/issue %{buildroot}%{_datadir}/%{name}/fresh/issue.net
echo >> %{buildroot}%{_datadir}/%{name}/fresh/issue

install -m 0644 release-notes-fresh.txt %{buildroot}%{_datadir}/%{name}/fresh/release-notes-en.txt
install -m 0644 os-release.fresh %{buildroot}%{_datadir}/%{name}/fresh/os-release
install -m 0644 product.id.fresh %{buildroot}%{_datadir}/%{name}/fresh/product.id
install -m 0644 README.urpmi.fresh %{buildroot}%{_datadir}/%{name}/fresh/README.urpmi
install -m 0644 index.html.fresh %{buildroot}%{_datadir}/%{name}/fresh/index.html
install -m 0644 branding.macros.fresh %{buildroot}%{_datadir}/%{name}/fresh/branding.macros

install -m 0644 %{SOURCE101} %{buildroot}%{_datadir}/%{name}/fresh/
pushd %{buildroot}%{_datadir}/%{name}/fresh/
tar xzvf %{SOURCE102}
popd

cat > %{buildroot}%{_datadir}/%{name}/fresh/lsb-release << EOF
LSB_VERSION=
DISTRIB_ID=RosaDesktopFresh
DISTRIB_RELEASE=%{fresh_platform}
DISTRIB_CODENAME=Fresh
DISTRIB_DESCRIPTION="ROSA Desktop Fresh R8.1"
EOF

%endif # product_product == Fresh

%if %{product_product} == "Enterprise"
mkdir -p %{buildroot}%{_datadir}/%{name}/red
echo "ROSA Enterprise Desktop X3 release %{fresh_platform} for %{_target_cpu}" > %{buildroot}%{_datadir}/%{name}/red/rosa-release

cp -p %{buildroot}%{_datadir}/%{name}/red/rosa-release %{buildroot}%{_datadir}/%{name}/red/issue
echo "Kernel \r on an \m (\l)" >> %{buildroot}%{_datadir}/%{name}/red/issue
cp -p %{buildroot}%{_datadir}/%{name}/red/issue %{buildroot}%{_datadir}/%{name}/red/issue.net
echo >> %{buildroot}%{_datadir}/%{name}/red/issue

install -m 0644 release-notes-red.txt %{buildroot}%{_datadir}/%{name}/red/release-notes-en.txt
install -m 0644 os-release.red %{buildroot}%{_datadir}/%{name}/red/os-release
install -m 0644 product.id.red %{buildroot}%{_datadir}/%{name}/red/product.id
install -m 0644 README.urpmi.red %{buildroot}%{_datadir}/%{name}/red/README.urpmi
install -m 0644 index.html.red %{buildroot}%{_datadir}/%{name}/red/index.html
install -m 0644 branding.macros.red %{buildroot}%{_datadir}/%{name}/red/branding.macros

install -m 0644 %{SOURCE101} %{buildroot}%{_datadir}/%{name}/red/
pushd %{buildroot}%{_datadir}/%{name}/red/
tar xzvf %{SOURCE102}
popd

cat > %{buildroot}%{_datadir}/%{name}/red/lsb-release << EOF
LSB_VERSION=
DISTRIB_ID=RosaDesktopEnterprise
DISTRIB_RELEASE=%{fresh_platform}
DISTRIB_CODENAME=Red
DISTRIB_DESCRIPTION="ROSA Enterprise Desktop X3"
EOF

%endif # product_product == Enterprise


%posttrans common
# ugly workaround: rpm package not installed
mkdir -p /etc/rpm/macros.d/
# workaround for updating from rosa-release-* packages - we will replace real files with symlinks
for f in %{_sysconfdir}/sysconfig/system %{_datadir}/doc/en_license.html %{_datadir}/doc/ru_license.html %{_sysconfdir}/profile.d/10rosa-release.csh %{_sysconfdir}/profile.d/10rosa-release.sh; do
if [[ -f $f ]] && [[ ! -L $f ]] ; then rm -f $f ; fi ; done
update-alternatives --install  %{_sysconfdir}/sysconfig/system branding-system %{_datadir}/%{name}/branding-system 90 --slave  %{_datadir}/doc/en_license.html en_license.html %{_datadir}/%{name}/en_license.html --slave %{_datadir}/doc/ru_license.html ru_license.html %{_datadir}/%{name}/ru_license.html --slave %{_sysconfdir}/profile.d/10rosa-release.csh 10rosa-release.csh %{_datadir}/%{name}/10rosa-release.csh --slave %{_sysconfdir}/profile.d/10rosa-release.sh 10rosa-release.sh  %{_datadir}/%{name}/10rosa-release.sh

%preun common
if [ $1 = 0 ]; then
    update-alternatives --remove branding-system %{_datadir}/%{name}/branding-system
fi

%postun common
if [ "$1" -ge "1" ]; then
    update-alternatives --set branding-system %{_datadir}/%{name}/branding-system
fi

%define issue_files %{_sysconfdir}/issue %{_sysconfdir}/issue.net
%define issue_slave --slave %{_sysconfdir}/issue issue %{_datadir}/%{name}/%{flavour}/issue --slave %{_sysconfdir}/issue.net issue.net %{_datadir}/%{name}/%{flavour}/issue.net

%define release_post(s) \
%posttrans %{-s:%1} \
%define flavour %1\
cp -f %{_datadir}/%{name}/%{flavour}/os-release %{_sysconfdir}/os-release\
cp -f %{_datadir}/%{name}/%{flavour}/rosa-release %{_sysconfdir}/system-release\
for f in %{_sysconfdir}/release %{_sysconfdir}/redhat-release %{_datadir}/doc/HTML/index.html %{_sysconfdir}/product.id %{_sysconfdir}/mandriva-release %{issue_files} %{_sysconfdir}/rosa-release; \
do \
if [[ -f $f ]] && [[ ! -L $f ]] ; then rm -f $f ; fi ; done \
update-alternatives --install %{_sysconfdir}/release flavour-release %{_datadir}/%{name}/%{flavour}/rosa-release 90 --slave %{_sysconfdir}/redhat-release redhat-release %{_datadir}/%{name}/%{flavour}/rosa-release --slave %{_sysconfdir}/mandrake-release mandrake-release %{_datadir}/%{name}/%{flavour}/rosa-release --slave %{_sysconfdir}/product.id product.id %{_datadir}/%{name}/%{flavour}/product.id  --slave %{_sysconfdir}/mandriva-release mandriva-release %{_datadir}/%{name}/%{flavour}/rosa-release --slave %{_sysconfdir}/rosa-release rosa-release %{_datadir}/%{name}/%{flavour}/rosa-release --slave %{_datadir}/doc/HTML/index.html index.html %{_datadir}/%{name}/%{flavour}/index.html --slave %{_sysconfdir}/rpm/macros.d/branding.macros branding.macros %{_datadir}/%{name}/%{flavour}/branding.macros %{issue_slave}\
cp -f %{_datadir}/%{name}/%{flavour}/lsb-release %{_sysconfdir}/lsb-release\
/usr/sbin/update-grub2 \

%define release_preun(s) \
%preun %{-s:%1} \
if [ $1 = 0 ]; then \
%define flavour %1\
update-alternatives --remove flavour-release %{_datadir}/%{name}/%{flavour}/rosa-release\
fi\

%define release_postun(s) \
%postun %{-s:%1} \
if [ "$1" -ge "1" ]; then \
%define flavour %1\
update-alternatives --set flavour-release %{_datadir}/%{name}/%{flavour}/rosa-release\
fi\

%if %{product_product} == "Certified"
%release_post -s Cobalt
%release_post -s Chrome
%release_post -s current
%release_post -s Nickel 

%release_preun -s Cobalt
%release_preun -s Chrome
%release_preun -s current
%release_preun -s Nickel 

%release_postun -s Cobalt
%release_postun -s Chrome
%release_postun -s current
%release_postun -s Nickel 

%endif

%if %{product_product} == "Enterprise"
%release_post -s red
%release_preun -s red
%release_postun -s red
%endif

%if %{product_product} == "EE" || %{product_product} == "Free" || %{product_product} == "Fresh"
%release_post -s fresh
%release_preun -s fresh
%release_postun -s fresh
%endif

%files common
%{_datadir}/%{name}/10rosa-release.csh
%{_datadir}/%{name}/10rosa-release.sh
%{_datadir}/%{name}/en_license.html
%{_datadir}/%{name}/ru_license.html
%{_datadir}/%{name}/branding-system
%{_sysconfdir}/minsysreqs
%{_sysconfdir}/sysconfig/desktop
%dir %{_datadir}/%{name}

%if %{product_product} == "Certified"
%files Chrome
%{_datadir}/%{name}/Chrome
%dir %{_datadir}/doc/HTML/
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release

%files Cobalt
%{_datadir}/%{name}/Cobalt
%dir %{_datadir}/doc/HTML/
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release

%files Nickel
%{_datadir}/%{name}/Nickel
%dir %{_datadir}/doc/HTML/
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release

%files current
%{_datadir}/%{name}/current
%dir %{_datadir}/doc/HTML/
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release

%endif

%if %{product_product} == "Enterprise"
%files red
%{_datadir}/%{name}/red
%dir %{_datadir}/doc/HTML/
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release
%endif

%if %{product_product} == "EE" || %{product_product} == "Free" || %{product_product} == "Fresh"
%files fresh
%doc CREDITS
%dir %{_datadir}/doc/HTML/
%{_datadir}/%{name}/fresh
%ghost %{_sysconfdir}/lsb-release
%ghost %{_sysconfdir}/os-release
%ghost %{_sysconfdir}/system-release
%endif

%changelog
